#!/bin/sh

CDIR="/tmp/cpe3"
PFRM_DIR=/work/pfrm1.0

homedir=`pwd`
echo homedir = $homedir

# Check to see if $CDIR exists
if   [ -d $CDIR ] ; then
   echo -n " "
elif [ -e $CDIR ] ; then
   rm -rf $CDIR
   mkdir  $CDIR
else
   mkdir  $CDIR
fi

if cd $CDIR ; then
    echo cd $CDIR
else
    echo could not cd to $CDIR
    exit 1
fi

rm -f *.dat

for dir in data filetrans options parameter ; do
  
  if [ -d $dir ] ; then
     rm -f ${dir}/*
  elif [ -e $dir ] ; then
     rm -rf $dir
     mkdir $dir   > /dev/null 2>&1
  else
     mkdir $dir   > /dev/null 2>&1
  fi
  mkdir $dir      > /dev/null 2>&1

done

cd $homedir

cp $PFRM_DIR/dps.param $CDIR

DEVICE_SERIAL_NUMBER=`ifconfig bdg | head -n 1 | awk '{print $5}'| tr -d ':'`
sed -i "s/DEVICE_SERIAL_NUMBER/$DEVICE_SERIAL_NUMBER/g" /tmp/cpe3/dps.param

rm -f SENT.log TEST.log RECV.log

$PFRM_DIR/dimclient

#end
